/*
Copyright (C) 2003 Frank Balbach

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.demo.crypto;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.regex.*;
import java.io.*;

/*import de.uni_luebeck.tcs.hochschultag.*;*/


//public class Decaesar extends TCSDemoAdapter {
public class Decaesar {
    //protected static final String FILE_BASE = "de/uni_luebeck/tcs/demo/crypto/resources/";
    protected static final String FILE_BASE = "resources/";

    //JFrame theFrame = new JFrame("Monoalphabetische Chiffrierung");
    JPanel thePanel = new JPanel();
    LettermapPanel upMap = new LettermapPanel(false);
    LettermapPanel midMap = new LettermapPanel(false);
    LettermapPanel lowMap = new LettermapPanel(false);
   
    JCheckBox stat1Check[];
    Lettermap solveMap;
    //int[] authorFreq;
//    int[] inputRank;
    char[] authorRank = new char[27];
//    int[][] inputFreq2;
   
    Letterline deText[] = new Letterline[5];
    
    JTextArea origTextArea;
    
    JCheckBox editCheckBox = new JCheckBox("Manuelle Eingabe");

    JRadioButton goetheButton = new JRadioButton("Goethe");
    JRadioButton mayButton = new JRadioButton("May");
    JRadioButton wegenerButton = new JRadioButton("Wegener");
    JButton continueButton1 = new JButton(">");
    JButton continueButton2 = new JButton(">>");
    JButton continueButton3 = new JButton(">>>");
    JButton contAutoButton = new JButton("Automatisch");
    JButton randButton = new JButton("Zufllig");
    JSlider eagerSlider = new JSlider(1, 10, 1);

    Workbench workbench;

    private Color upColor = new Color(190,210,190);
    private Color midColor = new Color(210,190,190);
    private Color lowColor = new Color(190,190,210);

    // fr den crack_it - Algorithmus
    HashSet allowed_words = new HashSet(1000);
    int crack_counter = 0;
    /** Bildet 1, 2, 3 Zeichen lange {@link String Strings} auf {@link Double Doubles},
      die die relative Hufigkeit des Strings beim gewhlten Autor angeben.*/
    HashMap authorFreq = new HashMap(8000);
    /** Bildet 1, 2 Zeichen lange {@link String Strings} auf {@link Double Doubles},
      die die relative Hufigkeit des Strings in der kodierten Eingabe angeben.*/
    HashMap inputFreq = new HashMap(100);
    int VERBOSE = 0;
    int VERBOSE_C = 0;
    int VERBOSE_A = 0;
    int STEP = 0;

    JLabel algoOutLabel = new JLabel("---");
    
    Cracker theCracker = new Cracker();
    Thread crackThread = new Thread(theCracker);
    
    
    public Decaesar() {
	//super("Decaesar");
	/*theFrame.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		//theFrame.dispose();
		System.exit(0);
	    }
	});*/
	//TODO: Box statt JPanel+BoxLayout
	//Box upPanel = new Box(BoxLayout.X_AXIS);
	JPanel upPanel = new JPanel();
	upPanel.setLayout(new BoxLayout(upPanel, BoxLayout.X_AXIS));
	upPanel.setBackground(upColor);
	
	JPanel midPanel = new JPanel();
	//Box midPanel = new Box(BoxLayout.X_AXIS);
	midPanel.setLayout(new BoxLayout(midPanel, BoxLayout.X_AXIS));
	midPanel.setBackground(midColor);
	
	JPanel lowPanel = new JPanel();
	//Box lowPanel = new Box(BoxLayout.X_AXIS);
	lowPanel.setLayout(new BoxLayout(lowPanel, BoxLayout.X_AXIS));
	lowPanel.setBackground(lowColor);
	
	//theFrame.getContentPane().setLayout(new BoxLayout(theFrame.getContentPane(), BoxLayout.Y_AXIS));
	thePanel.setLayout(new BoxLayout(thePanel, BoxLayout.Y_AXIS));
	//thePanel.setMaximumSize(new Dimension(1280,650));
	//thePanel.setPreferredSize(new Dimension(1280,650));

	//theFrame.getContentPane().add(upPanel);
	//theFrame.getContentPane().add(Box.createVerticalStrut(10));
	//theFrame.getContentPane().add(midPanel);
	//theFrame.getContentPane().add(Box.createVerticalStrut(10));
	//theFrame.getContentPane().add(lowPanel);
	
	thePanel.add(upPanel);
	//thePanel.add(Box.createVerticalGlue());
	thePanel.add(midPanel);
	//thePanel.add(Box.createVerticalGlue());
	thePanel.add(lowPanel);

	deText[0] = new Letterline("LIEBER LESER WEISST DU WAS",32,20);
	deText[1] = new Letterline("DAS WORT GREENHORN BEDEUTET",32,20);
	deText[2] = new Letterline("EINE HOECHST AERGERLICHE UND",32,20);
	deText[3] = new Letterline("DESPEKTIERLICHE BEZEICHNUNG",32,20);
	deText[4] = new Letterline("FUER DENJENIGEN AUF DEN SIE",32,20);

/*	Letterline enText[] = new Letterline[5];
	enText[0] = new Letterline("LIEBER LESER, WEISST DU, WAS",40,30);
	enText[1] = new Letterline("DAS WORT GREENHORN BEDEUTET.",40,30);
	enText[2] = new Letterline("EINE HOECHST AERGERLICHE UND",40,30);
	enText[3] = new Letterline("DESPEKTIERLICHE BEZEICHNUNG",40,30);
	enText[4] = new Letterline("FUER DENJENIGEN, AUF DEN SIE",40,30);*/
	
	Letterline origText[] = new Letterline[5];
	/*origText[0] = new Letterline("LIEBER LESER WEISST DU WAS",32,30);
	origText[1] = new Letterline("DAS WORT GREENHORN BEDEUTET",32,30);
	origText[2] = new Letterline("EINE HOECHST AERGERLICHE UND",32,30);
	origText[3] = new Letterline("DESPEKTIERLICHE BEZEICHNUNG",32,30);
	origText[4] = new Letterline("FUER DENJENIGEN AUF DEN SIE",32,30);*/
	origText[0] = new Letterline("EINLEITUNG IMMER FAELLT MIR WENN",32,20);
	origText[1] = new Letterline("ICH AN DEN INDIANER DENKE DER",32,20);
	origText[2] = new Letterline("TUERKE EIN DIES HAT SO SONDERBAR",32,20);
	origText[3] = new Letterline("ES ERSCHEINEN MAG DOCH SEINE",32,20);
	origText[4] = new Letterline("BERECHTIGUNG MAG ES ZWISCHEN",32,20);


	upMap.setBackground(upColor);
	lowMap.setBackground(lowColor);
	
	solveMap = new Lettermap(true);
	workbench = new Workbench(origText, upMap);
	workbench.setDeMap(solveMap);
	workbench.setBackground(midColor);

/*	JLabel arrow1 = new JLabel(new ImageIcon("pfeil.gif"));
	arrow1.setAlignmentX(JLabel.RIGHT_ALIGNMENT);
	JLabel arrow2 = new JLabel(new ImageIcon("pfeil.gif"));*/

	JPanel upleftPanel = new JPanel();
	upleftPanel.setLayout(new BoxLayout(upleftPanel, BoxLayout.X_AXIS));
	upleftPanel.setBorder(BorderFactory.createRaisedBevelBorder());
	JPanel midleftPanel = new JPanel();
	midleftPanel.setLayout(new BoxLayout(midleftPanel, BoxLayout.X_AXIS));
	JPanel lowleftPanel = new JPanel();
	lowleftPanel.setLayout(new BoxLayout(lowleftPanel, BoxLayout.Y_AXIS));
	lowleftPanel.setBorder(BorderFactory.createRaisedBevelBorder());

	// midrightBox
	Box midrightBox = new Box(BoxLayout.Y_AXIS);
	Box authorBox = new Box(BoxLayout.X_AXIS);
	authorBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Autor"));
	ButtonGroup authorGroup = new ButtonGroup();
	authorGroup.add(goetheButton);
	authorGroup.add(mayButton);
	authorGroup.add(wegenerButton);
	goetheButton.setSelected(true);
	authorBox.add(Box.createHorizontalGlue());
	authorBox.add(goetheButton);
	authorBox.add(mayButton);
	authorBox.add(wegenerButton);
	authorBox.add(Box.createHorizontalGlue());
	
	midrightBox.add(Box.createVerticalGlue());
	midrightBox.add(authorBox);
	midrightBox.add(Box.createVerticalGlue());
	
	goetheButton.setBackground(midColor);
	mayButton.setBackground(midColor);
	wegenerButton.setBackground(midColor);
	randButton.setBackground(upColor);

	class AuthorButtonListener implements ActionListener {
	    public void actionPerformed(ActionEvent e) {
		readFrequencies();
	    }
	}
	
	AuthorButtonListener abl = new AuthorButtonListener();
	
	goetheButton.addActionListener(abl);
	mayButton.addActionListener(abl);
	wegenerButton.addActionListener(abl);

	contAutoButton.setBackground(midColor);
	contAutoButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    theCracker.autopilot = !theCracker.autopilot;
		    if (theCracker.autopilot) {
			theCracker.runToStep = theCracker.crack_counter+0;
			theCracker.wakeup();
		    }
		}
	    });
 
	class ContinueButtonListener implements ActionListener {
		public void actionPerformed(ActionEvent ae) {
		    JButton src = (JButton) ae.getSource();
		    int incr = 1;
		    if (src == continueButton2) incr = 10;
		    if (src == continueButton3) incr = 100;
		    theCracker.runToStep += incr;
		    //System.out.println("listener:tostep="+theCracker.runToStep);
		    theCracker.wakeup();
		}
	}
		    
	ContinueButtonListener cbl = new ContinueButtonListener();
	continueButton1.setBackground(midColor);
	continueButton1.addActionListener(cbl);
	continueButton2.setBackground(midColor);
	continueButton2.addActionListener(cbl);
	continueButton3.setBackground(midColor);
	continueButton3.addActionListener(cbl);

	eagerSlider.setBackground(midColor);
	eagerSlider.setSnapToTicks(true);
	eagerSlider.setMajorTickSpacing(1);
	eagerSlider.setPaintTicks(true);
	//eagerSlider.setPaintLabels(true);
	eagerSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    int[] params = new int[2];
		    int val = eagerSlider.getValue();
		    params[0] = val/2+1;
		    params[1] = (val-1)/2;
		    theCracker.params = params;
		}});

	
	
	Box algoBoxLow = new Box(BoxLayout.X_AXIS);
	Box algoBoxMid = new Box(BoxLayout.X_AXIS);
	algoOutLabel.setForeground(Color.red);
	algoOutLabel.setBorder(BorderFactory.createRaisedBevelBorder());
	algoOutLabel.setMaximumSize(new Dimension(310,30));
	algoOutLabel.setMinimumSize(new Dimension(310,30));
	algoOutLabel.setPreferredSize(new Dimension(310,30));
	algoBoxLow.add(algoOutLabel);
	
	Box algoBoxUp = new Box(BoxLayout.X_AXIS);
	algoBoxUp.add(Box.createHorizontalGlue());
	algoBoxUp.add(continueButton1);
	algoBoxUp.add(continueButton2);
	algoBoxUp.add(continueButton3);
	algoBoxUp.add(Box.createHorizontalGlue());
	algoBoxUp.add(contAutoButton);
	algoBoxUp.add(Box.createHorizontalGlue());
	
	//algoBoxMid.add(new JLabel("Eifer: "));
	algoBoxMid.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Eifer"));
	algoBoxMid.add(eagerSlider);
	//algoBoxMid.add(Box.createHorizontalGlue());
	    
	Box algoBox = new Box(BoxLayout.Y_AXIS);
	algoBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Abarbeiten"));
	algoBox.add(algoBoxUp);
	//algoBox.add(algoBoxMid);
	algoBox.add(Box.createVerticalGlue());
	algoBox.add(algoBoxLow);
	
	//midrightBox.add(Box.createVerticalGlue());
	midrightBox.add(algoBoxMid);
	//midrightBox.add(Box.createVerticalGlue());
	midrightBox.add(algoBox);
	//midrightBox.add(Box.createVerticalGlue());
	midrightBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Dekodierungs-Algorithmus"));

	JTabbedPane statPane = new JTabbedPane();
	statPane.setBackground(upColor);
	statPane.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Statistik"));
	Box stat1Box = new Box(BoxLayout.X_AXIS);
	stat1Box.setBackground(midColor);
	Box stat2Box = new Box(BoxLayout.X_AXIS);
	stat2Box.setBackground(midColor);
	Box stat3Box = new Box(BoxLayout.X_AXIS);
	stat3Box.setBackground(midColor);

	JPanel stat1Table = new JPanel(new GridLayout(27, 1));
	stat1Table.setBackground(midColor);
	stat1Check = new JCheckBox[27];
	

	//Stat1CheckListener check1Listener = new Stat1CheckListener();

	readFrequencies();
	read_allowed_words();
	
	for (int i=0; i<27; i++) {
	    //System.out.println(authorFreq[i]);
	    stat1Check[i] = new JCheckBox(String.valueOf(authorRank[i])+" "+i/1.23+" %");
	    stat1Check[i].setBackground(midColor);
	    //stat1Check[i].addActionListener(check1Listener);
	    stat1Table.add(stat1Check[i]);
	}
	JScrollPane stat1ScrollPane = new JScrollPane(stat1Table);
	stat1ScrollPane.setBackground(midColor);
	stat1ScrollPane.getVerticalScrollBar().setUnitIncrement(8);
	stat1ScrollPane.getVerticalScrollBar().setBackground(midColor);
	//stat1ScrollPane.setPreferredSize(new Dimension(50,100));
	stat1Box.add(stat1ScrollPane);
	
	statPane.add(stat1Box);
	statPane.setTitleAt(0, "Einzelne");
	statPane.setBackgroundAt(0, midColor);
	statPane.add(stat2Box);
	statPane.setTitleAt(1, "Paare");
	statPane.setBackgroundAt(1, midColor);
	statPane.add(stat3Box);
	statPane.setTitleAt(2, "Tripel");
	statPane.setBackgroundAt(2, midColor);
	
	statPane.setMaximumSize(new Dimension(statPane.getPreferredSize().width, 200));
	statPane.setPreferredSize(new Dimension(statPane.getPreferredSize().width, 200));
	//midrightBox.add(statPane);
	

	for (int i=0; i<5; i++) {
	    lowMap.addListener(deText[i]);
	}
	
	Box uprightBox = new Box(BoxLayout.Y_AXIS);
	uprightBox.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Kodierungstabelle"));
	Box newinputBox = new Box(BoxLayout.X_AXIS);
	//JCheckBox editCheckBox = new JCheckBox("Manuelle Eingabe");
	editCheckBox.setBackground(upColor);
	editCheckBox.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent ae) {
		    boolean sel = ((JCheckBox) ae.getSource()).isSelected();
		    
		    if (sel == false) {  // los geht's
			lowMap.becomeInverseOf(upMap);
			//System.out.println("wel0: "+workbench.eLine[0]);
			workbench.setText(origTextArea);

			//System.out.println("wel: "+workbench.eLine[0]);
			workbench.setEnMap(upMap.getMap());
			
		     	solveMap = new Lettermap(true);
			workbench.setDeMap(solveMap);

			for (int i=0; i<5; i++) {
			    //System.out.println("wget0: "+workbench.getEnText(0));
			    deText[i].setOriginalText(workbench.getEnText(i));
			    deText[i].encrypt(lowMap.getMap());
			}

			setInputFreq();
			
			theCracker.restart = true;
			theCracker.wakeup();
		    }
		    
		    if (sel == true) {
			theCracker.autopilot = false;
			for (int i=0; i<27; i++) {
			    stat1Check[i].setSelected(false);
			}
		    }
			
		    for (int i=0; i<27; i++) {
			stat1Check[i].setEnabled(!sel);
		    }
		    
		    randButton.setEnabled(sel);
		    origTextArea.setEditable(sel);
		    upMap.setEditable(sel);
		    upMap.setEnabled(sel);
		    origTextArea.setEnabled(sel);
		    workbench.setEnabled(!sel);
		    continueButton1.setEnabled(!sel);
		    continueButton2.setEnabled(!sel);
		    continueButton3.setEnabled(!sel);
		    contAutoButton.setEnabled(!sel);
		    lowMap.setEnabled(!sel);
		    lowMap.setEditable(!sel);
		    for (int i=0; i<deText.length; i++) {
			deText[i].setEnabled(!sel);
		    }
		}});

	randButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    upMap.randomize();
		}});
		    
	newinputBox.add(editCheckBox);
	newinputBox.add(Box.createHorizontalGlue());
	newinputBox.add(randButton);

	uprightBox.add(newinputBox);
	uprightBox.add(Box.createVerticalGlue());
	uprightBox.add(upMap);
	
	origTextArea = new JTextArea(5, 32);
	origTextArea.setDocument(new UpcaseDocument());
	origTextArea.setFont(new Font("Monospaced", Font.PLAIN, 20));
	origTextArea.setBackground(upColor);
	origTextArea.setEditable(false);
	for (int i=0; i<origText.length-1; i++) {
	    origTextArea.append(origText[i].toString()+"\n");
	}
	origTextArea.append(origText[origText.length-1].toString());
	JScrollPane origTextScrollPane = new JScrollPane(origTextArea);
	upleftPanel.add(origTextScrollPane);
	
//	upleftPanel.add(arrow1);
//	lowleftPanel.add(arrow2);
	for (int i=0; i<deText.length; i++) {
	    deText[i].setOriginalText(origText[i].toString());
	    lowleftPanel.add(deText[i]);
	    deText[i].setBackground(lowColor);
	}

	upMap.setMap(1);

	workbench.setEnMap(upMap.getMap());
	
	Box lowrightPanel = new Box(BoxLayout.Y_AXIS);
	//lowrightPanel.setBackground(lowColor);
	//lowrightPanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Dekodierungstabelle"));
	//lowrightPanel.add(Box.createVerticalGlue());
	lowMap.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Dekodierungstabelle"));
	//lowrightPanel.add(lowMap);
	
	upPanel.add(upleftPanel);
	upPanel.add(uprightBox);
	midPanel.add(workbench);
	midPanel.add(midrightBox);
	lowPanel.add(lowleftPanel);
	lowPanel.add(lowMap);
	
	//theFrame.pack();
	
	// nur fr TCSDemo auskommentiert
	 //theFrame.setVisible(true);
	 //thePanel.setVisible(true);
	//theFrame.getContentPane().setVisible(true);

	setInputFreq();
    }

    
    private class MapQuality {
	int flag;
	double quality;
	HashMap map;
	
	MapQuality(int f, double q, HashMap m) {
	    flag = f;
	    quality = q;
	    map = m;
	}

	public String toString() {
	    return "["+String.valueOf(flag)+", "+String.valueOf(quality)+", "+map.toString()+"]";
	}
    }

    private void print_crack_statistics(String text, HashMap deMap) {
	String detext = apply_map_to_text(deMap, text);
	String ortext = origTextArea.getText();
	ortext = ortext.replaceAll("\n", " ");
	System.out.println(detext+".");
	System.out.println(ortext+".");
	System.out.println(detext.length());
	System.out.println(ortext.length());
	System.out.println(text.length());
	int corr = 0;
	for (int i=0; i<text.length(); i++) {
	    if (detext.charAt(i) == ortext.charAt(i)) corr++;
	}
	System.out.println("%"+corr);
	System.out.println("***** KORREKTHEIT: "+(100.0*corr/text.length())+"%");
    }
    
    
    private void setInputFreq() {
	inputFreq.clear();
	
	String text = workbench.getEnText();
	for (int i=0; i<text.length(); i++) {
	    String key = text.substring(i, i+1);
	    if (inputFreq.containsKey(key)) {
		inputFreq.put(key, new Integer(((Integer) inputFreq.get(key)).intValue()+1));
	    } else {
		inputFreq.put(key, new Integer(1));
	    }
	    if (i < text.length() - 1) {
		key = text.substring(i, i+2);
		if (inputFreq.containsKey(key)) {
		    inputFreq.put(key, new Integer(((Integer) inputFreq.get(key)).intValue()+1));
		} else {
		    inputFreq.put(key, new Integer(1));
		}
	    }
	}

	for (Iterator i = inputFreq.keySet().iterator(); i.hasNext();){
	    String key = (String) i.next();
	    int val = ((Integer) inputFreq.get(key)).intValue();
	    if (key.length()==1) {
		inputFreq.put(key, new Double((double) val / text.length()));
	    } else { 
		inputFreq.put(key, new Double((double) val / text.length()));
	    }
	}

	if (VERBOSE >= 2) {
	    System.out.println("inputFreq: "+inputFreq);
	}
    }

    private void readFrequencies() {
	if (theCracker.autopilot) {
	    return;
	}

	authorFreq.clear();
	
	String filename = FILE_BASE;
	if (goetheButton.isSelected()) {
	    filename += "Werther_g";
	} else if (mayButton.isSelected()) {
	    filename += "winnetou1_g";
	} else {
	    filename += "eabuch_g";
	}
	
	//filename += "winnetou1_g";
	java.net.URL fileURL;

	BufferedReader file;
	try {
	    fileURL = getClass().getResource(filename+".stat1");
	    file = new BufferedReader(new InputStreamReader(fileURL.openStream()));

	    File fn = new File(filename+".stat1");
	    //System.out.println(fn.getAbsolutePath());
	    //System.out.println(fn.getCanonicalPath());
	    //file = new BufferedReader(new FileReader(new File(filename+".stat1")));
	    String line = file.readLine();
	    int i = 0;
	    
	    while (line != null) {
		String key = line.substring(0, 1);
		double wk = Double.parseDouble(line.substring(line.indexOf("(")+1, line.indexOf("%"))) / 100.0;
		Double wkt = new Double(wk);
		authorFreq.put(key, wkt);
		authorRank[26-i] = key.charAt(0);
		i++;
		line = file.readLine();
	    }

	    file.close();
	} catch (IOException e) {System.err.println(e.getMessage());}
	
	try {
	    fileURL = getClass().getResource(filename+".stat2");
	    file = new BufferedReader(new InputStreamReader(fileURL.openStream()));
	    //file = new BufferedReader(new FileReader(new File(filename+".stat2")));
	    String line = file.readLine();
	    int i = 0;
	    
	    while (line != null) {
		String key = line.substring(0, 2);
		double wk = Double.parseDouble(line.substring(line.indexOf("(")+1, line.indexOf("%"))) / 100.0;
		Double wkt = new Double(wk);
		
		authorFreq.put(key, wkt);
		i++;
		line = file.readLine();
	    }

	    file.close();
	} catch (IOException e) {System.err.println(e.getMessage());}
	
	try {
	    fileURL = getClass().getResource(filename+".stat3");
	    file = new BufferedReader(new InputStreamReader(fileURL.openStream()));
	    //file = new BufferedReader(new FileReader(new File(filename+".stat3")));
	    String line = file.readLine();
	    int i = 0;
	    
	    while (line != null) {
		String key = line.substring(0, 3);
		double wk = Double.parseDouble(line.substring(line.indexOf("(")+1, line.indexOf("%"))) / 100.0;
		if (wk > 0.0) {
		    Double wkt = new Double(wk);
		    authorFreq.put(key, wkt);
		}
		i++;
		line = file.readLine();
	    }

	    file.close();
	} catch (IOException e) {System.err.println(e.getMessage());}

	if (VERBOSE > 0) {
	    System.out.println("authorFreq: "+authorFreq);
	    System.out.println("authorRank: "+authorRank.length);
	}
    }

    private void read_allowed_words() {
	try {
	    java.net.URL fileURL = getClass().getResource(FILE_BASE+"allowed_words.txt");
	    BufferedReader file = new BufferedReader(new InputStreamReader(fileURL.openStream()));
	    //BufferedReader file = new BufferedReader(new FileReader(new File(FILE_BASE + "allowed_words.txt")));
	    String line = file.readLine();
	    int i = 0;
	    
	    while (line != null) {
		String key = line.trim();
		allowed_words.add(key);
		i++;
		line = file.readLine();
	    }

	    file.close();
	} catch (Exception e) {System.out.println(e.getMessage());}

	if (VERBOSE > 0) {
	    System.out.println("allowed_words: "+allowed_words);
	}
    }

    class Cracker implements Runnable {
	boolean restart = false;
	boolean autopilot = false;
	int runToStep = 0;
	int crack_counter = 0;
	int[] params = {1, 0};

	public void run() {
	    while (true) {
		crack_counter = 0;
		runToStep = 0;
		restart = false;
		//autopilot = false;
		
		HashMap solveMap = new HashMap(50);
		// Zuerst Leerzeichen und 'E' entdecken und zuweisen.
		
		
		int[] params = {2, 1};
		String text = workbench.getEnText();

		MapQuality mq = crack_it(solveMap, text);

		if (mq != null) {
		    workbench.setDeMap(mq.map);
		
		    algoOutLabel.setText("FERTIG!");
		    //System.out.println("***** flag:"+mq.flag+" map:"+mq.map+"estim.quality:"+mq.quality);
		    print_crack_statistics(text, mq.map);
		}
		autopilot = false;
		pause();
	    }
	}
	
	private MapQuality crack_it(HashMap deMap, String text) {
	    crack_counter++;

	    if (VERBOSE > 0) {
		System.out.println("crack_counter = "+crack_counter);
		System.out.println("runToStep = "+runToStep);
	    }
	    
	    if (autopilot) {
		runToStep = crack_counter;
		workbench.setDeMap(deMap);
	    } else {
	    while (crack_counter > runToStep) {
		workbench.setDeMap(deMap);
		//System.out.println("pausiere bei "+crack_counter);
		pause();
		if (restart) {
		    return null;
		}
	    }}

	    int SEARCH_WIDTH = params[0];
	    int ADD_STATS = params[1];
	    String detext = apply_map_to_text(deMap, text);

	    if (VERBOSE > 0) {
		System.out.println("deMap: "+deMap);
		System.out.println("detext: "+detext);
	    }


	    // prfen, ob detext vernnftig
	    int cfw = count_forbidden_words(detext);
	    int clf = count_low_freq_pairs(detext, 0.0001);
	    double decoded_perc = count_decoded_letters(detext) / (double) detext.length();

	    if (VERBOSE_C > 0) {
		System.out.println("cfw: "+cfw+" clf: "+clf+" decoded_perc: "+decoded_perc);
	    }

	    double quality = decoded_perc - 0.1*cfw - 0.1*clf;
	    if (cfw > 1 || clf > 1) { // falls nein, Rekursion beenden
		algoOutLabel.setText("FEHLSCHLAG");
		if (VERBOSE_A > 0) {
		    System.out.println("FEHLSCHLAG mit "+deMap);
		}
		return new MapQuality(0, quality, deMap);
	    }

	    // detext ist also vernnftig

	    // sind wir schon (fast) fertig?
	    if (decoded_perc > 0.999) {
		algoOutLabel.setText("FAST VOLLSTNDIG ENTSCHLSSELT");
		if (VERBOSE_A > 0) {
		    System.out.println("FERTIG mit "+deMap);
		}
		return new MapQuality(1, quality, deMap);
	    }

	    // wir machen also weiter

	    // Ersetzungsvorschlge aufgrund plausibler Wortergnzungen
	    Vector guesses = find_plausible_word(text, detext, deMap);
	    
	    // Ersetzungsvorschlge aufgrund Buchstabenhufigkeiten, falls
	    // ntig (guesses.size()==0) oder erwnscht (ADD_STATS>0)
	    if (guesses.size() < SEARCH_WIDTH || ADD_STATS > 0) {
		int TO_ADD = Math.max(SEARCH_WIDTH-guesses.size(), 0) + ADD_STATS;
		// hufigsten unentschlsselten Buchst. finden
		double max_freq = 0.0;
		char mf_letter = ' ';
		for (int i=0; i<27; i++) {
		    //System.out.println("substring:"+Lettermap.order.substring(i, i+1));
		    Double dbl = (Double) inputFreq.get(Lettermap.intToString(i));
		    if (dbl != null && !deMap.containsKey(new Character(Lettermap.intToChar(i)))) {
			double freq = dbl.doubleValue();
			if (freq >= max_freq) {
			    max_freq = freq;
			    mf_letter = Lettermap.intToChar(i);
			}
		    }
		}

		if (VERBOSE > 0) {
		    System.out.println("mf_letter="+mf_letter);
		}

		// hufigste noch freie Entschl.-Buchstaben suchen
		char[] mf_Letters = new char[TO_ADD];
		
		int adds = 0;
		for (int i=0; i<27; i++) {
		    if (!deMap.containsValue(new Character(authorRank[i]))) {
			mf_Letters[adds] = authorRank[i];
			if (VERBOSE > 0) {
			    System.out.println("mf_L[]:"+mf_Letters[adds]);
			}
			adds++;
			if (adds == TO_ADD) {
			    break;
			}
		    }
		}

		for (int i=0; i<adds; i++) {
		    Guess newguess = new Guess(mf_letter, mf_Letters[i]);
		    if (!guesses.contains(newguess)) {
			guesses.add(newguess);
		    }
		}
	    }
	    
	    if (VERBOSE > 0) {
		System.out.println("GUESSES:");
		for (int g=0; g<guesses.size(); g++) {
		    Guess gg = (Guess) guesses.get(g);
		    //System.out.println(""+gg);
		}
	    }


	    // rekursive Abstiege
	    HashMap best_map = deMap;
	    double best_quality = quality;
	    int best_flag = 0;

	    for (int g = 0; g<guesses.size(); g++) {
		Guess guess = (Guess) guesses.get(g);
		algoOutLabel.setText("VERSUCH:"+guess+" ...");
		if (VERBOSE_A > 0) {
		    System.out.println("AKTION: Versuche "+guess+" ...");
		}
		HashMap newmap = (HashMap) deMap.clone();
		newmap.put(new Character(guess.from), new Character(guess.to));

		if (VERBOSE > 0) {
		    System.out.println("newmap="+newmap);
		}
		MapQuality fl_qu_ma = crack_it(newmap, text);
		
		if (fl_qu_ma == null) {	// Neustart erwnscht
		    return null;
		}

		algoOutLabel.setText("RESULTAT: "+fl_qu_ma+".");
		if (VERBOSE_A > 0) {
		    System.out.println("RESULTAT: "+fl_qu_ma+".");
		}

		if (fl_qu_ma.quality > best_quality) {
		    best_quality = fl_qu_ma.quality;
		    best_map = (HashMap) fl_qu_ma.map.clone();
		    best_flag = fl_qu_ma.flag;
		}	    
	    }

	    // beste map zurckgeben
	    if (VERBOSE > 0) {
		System.out.println("EMPFEHLUNG: "+best_map+" mit quality="+best_quality);
	    }
	    return new MapQuality(best_flag, best_quality, best_map);
	}

	protected synchronized void pause() {
	    //System.out.println("pause...");
	    try {
		wait();
		//System.out.println("pause rum...");
	    } catch (InterruptedException e) {}
	}

	public synchronized void wakeup() {
	    notifyAll();
	}
    }

    public static String apply_map_to_text(HashMap deMap, String text) {
	StringBuffer ret = new StringBuffer(text.length());

	//System.out.println("apply:text="+text);
	for (int i=0; i<text.length(); i++) {
	    Character key = new Character(text.charAt(i));
	    if (deMap.containsKey(key)) {
		ret.append(((Character) deMap.get(key)).charValue());
	    } else {
		ret.append("?");
	    }
	}
	
	return ret.toString();
    }

    private int count_forbidden_words(String text) {
	int forb = 0;
	String[] words = text.split(" ");

	for (int i=0; i<words.length; i++) {
	    if (words[i].length()<=3 && words[i].length()>=1 &&
		    words[i].indexOf("?")==-1 &&
		    !allowed_words.contains(words[i])) {
		//System.out.println(words[i]+" ist VERBOTEN.");
		//System.out.println("allowed:"+allowed_words);
		forb++;
	    }
	}

	return forb;
    }

    private int count_low_freq_pairs(String text, double thresh) {
	int bad = 0;

	for (int i=0; i<text.length()-1; i++) {
	    String pair = text.substring(i, i+2);
	    if (pair.indexOf("?")==-1) {
		//System.out.println("authorFreq:"+authorFreq);
		//System.out.println("text:"+text);
		if (((Double) authorFreq.get(pair)).doubleValue() < thresh) {
		    bad++;
		    if (VERBOSE >= 2) {
			System.out.println(pair+" kommt (fast) nie vor.");
		    }
		} else {
		    if (i<text.length()-2 && text.charAt(i+2)!='?') {
			String trip = text.substring(i, i+3);
			if (!authorFreq.containsKey(trip) || ((Double) authorFreq.get(trip)).doubleValue() == 0.0) {
			    bad++;
			    if (VERBOSE >= 2) {
				System.out.println(trip+" kommt (fast) nie vor.");
			    }
			}
		    }
		}
	    }
	}

	return bad;
    }

    private int count_decoded_letters(String text) {
	int ret = 0;
	
	for (int i=0; i<text.length(); i++) {
	    if (text.charAt(i) != '?') {
		ret++;
	    }
	}

	return ret;
    }
    
    class Guess {
	char from, to;

	Guess(char f, char t) {
	    from = f;
	    to = t;
	}
	Guess(Character f, Character t) {
	    from = f.charValue();
	    to = t.charValue();
	}

	public boolean equals(Guess g) {
	    return (g.from == this.from && g.to == this.to);
	}

	public String toString() {
	    return String.valueOf(from)+" -> "+String.valueOf(to);
	}
    }
    
    private Vector find_plausible_word(String text, String detext, HashMap deMap) {
	Vector ret;
	int sp = detext.indexOf(" ");
	int sp2;

	while (sp!=-1 && sp<detext.length()-4) {
	    sp2 = detext.indexOf(" ", sp+1);
	    if (sp2-sp>=3 && sp2-sp<=4) {
		String wor = detext.substring(sp+1,sp2);
		ret = new Vector(5);
		if (wor.indexOf("?") != -1) {
		    Pattern pat = Pattern.compile(wor.replaceAll("\\?","(.)")+"$");
		    for (Iterator i = allowed_words.iterator(); i.hasNext(); ) {
			String aw = (String) i.next();
			Matcher mob = pat.matcher(aw);
			if (mob.matches()) {
			    for (int g=1; g<=mob.groupCount(); g++) {
				Character to = new Character(mob.group(g).charAt(0));
				Character fro = new Character(text.charAt(sp+1+mob.start(g)));
				if (!deMap.containsKey(fro) && !deMap.containsValue(to)) {
				    Guess newguess = new Guess(fro, to);
				    if (!ret.contains(newguess)) {
					ret.add(newguess);
				    }
				}
			    }
			}
		    }
		}
		if (ret.size() <= 3) {
		    return ret;
		}
	    }
	    sp = sp2;
	}
		
	return new Vector(0);
    }
    

    //    public void run() {
    public void start() {
	//super.start();
	theCracker.runToStep = 10;
	
	editCheckBox.doClick();
	editCheckBox.doClick();
	
	crackThread.start();	
    }
    
    public static void main(String args[]) {
	Decaesar d = new Decaesar();
	//d.theFrame.setVisible(true);
	d.start();
	JFrame mainFrame = new JFrame("Decaesar");
	//mainFrame.setContentPane(d.getComponent());
	mainFrame.getContentPane().add(d.getComponent());
	mainFrame.pack();
	mainFrame.setVisible(true);
	    
    }


    public void pause() {
	//super.pause();
	theCracker.autopilot = false;
	theCracker.runToStep = theCracker.crack_counter;
    }

    public void resume() {
	//super.resume();
    }

    public Component getComponent() {
	//return theFrame.getContentPane();
	//System.out.println("sizes:");
	/*System.out.println(thePanel.getPreferredSize());
	System.out.println(thePanel.getMaximumSize());
	System.out.println(thePanel.getMinimumSize());
	System.out.println(thePanel.getSize());
	//thePanel.setMaximumSize(thePanel.getMinimumSize());
	//thePanel.setPreferredSize(thePanel.getMinimumSize());*/
	thePanel.setPreferredSize(new Dimension(817, 684));
	//thePanel.validate();
	/*
	System.out.println(thePanel.getPreferredSize());
	System.out.println(thePanel.getMaximumSize());
	System.out.println(thePanel.getMinimumSize());
	System.out.println(thePanel.getSize());*/
	return thePanel;
    }
}

class Lettermap {
    private static final String order = "ABCDEFGHIJKLMNOPQRSTUVWXYZ ";
    private int map[] = new int[27];

    public Lettermap() {
	this(false);
    }

    public Lettermap(boolean blank) {
	if (blank) {
	    for (int i=0; i<27; i++) {
		map[i] = 26;
	    }
	} else {
	    for (int i=0; i<27; i++) {
		map[i] = i;
	    }
	}
    }
    
    public int getInt(int i) {
	return map[i];
    }

    public char getChar(int i) {
	return order.charAt(map[i]);
    }
    
    public String getString(int i) {
	return order.substring(map[i], map[i]+1);
    }

    public void putString(int k, String v) {
	map[k] = order.indexOf(v);
    }

    public void putChar(int k, char v) {
	map[k] = order.indexOf(v);
    }

    public void putInt(int k, int v) {
	map[k] = v;
    }

    public static String intToString(int n) {
	return order.substring(n, n+1);
    }
    
    public static char intToChar(int n) {
	return order.charAt(n);
    }

    public static int charToInt(char c) {
	return order.indexOf(c);
    }
    
    public static int stringToInt(String s) {
	return order.indexOf(s);
    }
    
}

// 0,1,...,9,A,B,C,...,Z, ,..        A->10, ..., Z->35, [BLANK]->30
class LettermapPanel extends JPanel {
    class LettermapPanelListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
	    int clicked = noOfSource((JButton) e.getSource());
	   
	    if (editable == false) {
		return;
	    }
	    
	    if (active == -1) {
		active = clicked;
		varButton[active].setForeground(Color.red);
	    } else {
		JButton lc = varButton[clicked];
		JButton la = varButton[active];
		
		int tmp = map.getInt(active);
		map.putInt(active, map.getInt(clicked));
		map.putInt(clicked, tmp);

		lc.setText(map.getString(clicked));
		la.setText(map.getString(active));
	
		la.setForeground(Color.black);
		active = -1;

		notifyListener();
	    }
	}

	private int noOfSource(JButton src) {
	    for (int i=0; i<varButton.length; i++) {
		if (varButton[i] == src) {
		    return i;
		}
	    }
	    System.err.println("Error in LettermapPanelListener.noOfSOurce()!");
	    return -1;
	}
	
	
    }
    
    private boolean editable = false;
    private Lettermap map;
    private JLabel fixLabel[];
    private JButton varButton[];
    private LettermapPanelListener listener = new LettermapPanelListener();
    private int active = -1;

    private Vector llListener = new Vector(1);


    public LettermapPanel(boolean ed) {
	super();
	
	this.editable = ed;
	
	Font font = new Font("Monospaced", Font.PLAIN, 15);
	
	fixLabel = new JLabel[27];
	varButton = new JButton[27];
	map = new Lettermap();
	for (int i=0; i<27; i++) {
	    fixLabel[i] = new JLabel(Lettermap.intToString(i));
	    fixLabel[i].setFont(font);
	    fixLabel[i].setBorder(BorderFactory.createEtchedBorder());
	    fixLabel[i].setPreferredSize(new Dimension(14,22));
	    fixLabel[i].setMaximumSize(new Dimension(14,22));
	    fixLabel[i].setMinimumSize(new Dimension(14,22));
	    varButton[i] = new JButton(map.getString(i));
	    varButton[i].setFont(font);
	    varButton[i].setBorder(BorderFactory.createEtchedBorder());
	    varButton[i].setPreferredSize(new Dimension(14,22));
	    varButton[i].setMaximumSize(new Dimension(14,22));
	    varButton[i].setMinimumSize(new Dimension(14,22));
	    varButton[i].addActionListener(listener);
	}


	int rows = 3;
	int cols = 9;
	
	this.setLayout(new GridLayout(rows,cols));

	for (int r=0; r<rows; r++) {
	    for (int c=0; c<cols*3-1; c++) {
		if (c%3 == 0) {
		    this.add(fixLabel[(c/3)*rows+r]);
		} else if (c%3 == 1) {
		    this.add(varButton[(c/3)*rows+r]);
		} else {
		    this.add(Box.createHorizontalGlue());
		}
	    }
	}
	
	this.setBorder(BorderFactory.createRaisedBevelBorder());
	//this.setMaximumSize(new Dimension(400, getPreferredSize().height));
    }

    public void notifyListener() {
    	for (int i=0; i<llListener.size(); i++) {
	    ((Letterline) llListener.get(i)).encrypt(map);
	}
    }

    public void removeListener(Letterline ll) {
	llListener.remove(ll);
    }
    
    public void addListener(Letterline ll) {
	llListener.add(ll);
    }

    public LettermapPanel() {
	this(false);
    }

    public void setBackground(Color c) {
	super.setBackground(c);
	if (varButton != null && fixLabel != null) {
	    for (int i=0; i<27; i++) {
		varButton[i].setBackground(c);
		fixLabel[i].setBackground(c);
	    }
	}
    }
    
    public Lettermap getMap() {
	return map;
    }

    public void setMap(int v) {
	for (int i=0; i<27; i++) {
	    map.putInt(i, (i+v) % 27);
	    varButton[i].setText(map.getString(i));
	}		
	notifyListener();
    }
    
    public void setMap(Lettermap map) {
	this.map = map;
	for (int i=0; i<27; i++) {
	    varButton[i].setText(map.getString(i));
	}
	notifyListener();
    }
    
    public void reset() {
	this.setMap(0);
    }

    public void setEnabled(boolean en) {
	for (int i=0; i<27; i++) {
	    varButton[i].setEnabled(en);
	    fixLabel[i].setEnabled(en);
	}
    }

    public void becomeInverseOf(LettermapPanel lmp) {
	map = new Lettermap();
	
	for (int i=0; i<27; i++) {
	    map.putInt(lmp.getMap().getInt(i), i);
	}

	setMap(map);
    }

    public void randomize() {
	java.util.Random ra = new Random();
	for (int i=0; i<100; i++) {
	    int r1 = ra.nextInt(27);
	    int r2 = ra.nextInt(27);
	    int t = map.getInt(r1);
	    map.putInt(r1, map.getInt(r2));
	    map.putInt(r2, t);
	}

	setMap(map);
    }

    public void setEditable(boolean ed) {
	this.editable = ed;
    }
}


class Letterline extends JPanel {
    private String content;
    private Font font;
    private int width;
    private JLabel letters[] = null;

    private String original;
    
    public Letterline(String c, int width) {
	this(c, width, 54);
    }
    
    public Letterline(String c, int width, int size) {
	super();
	
	this.width = width;
	this.font = new Font("Monospaced", Font.PLAIN, size);
	this.original = new String(c);
	this.letters = new JLabel[width];

	for (int i=0; i<width; i++) {
	    this.letters[i] = new JLabel("");
	    this.letters[i].setFont(this.font);
	    letters[i].setPreferredSize(new Dimension(size*2/3,size*11/10));
	    letters[i].setMaximumSize(new Dimension(size*2/3,size*11/10));
	    this.add(letters[i]);
	}
	
	setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
	setText(c);
	
	this.setAlignmentX(LEFT_ALIGNMENT);
	this.setBorder(BorderFactory.createEtchedBorder());
    }
    
    public Letterline(String c) {
	this(c, 40);
    }
    
    public Letterline() {
	this("", 40);
    }

    public void setOriginalText(String o) {
	//System.out.println("sot: "+o);
	original = o;
    }

    //XXX: sollte private sein. Text := Map(OriginalText)
    public void setText(String c) {
	if (c.length() > width) {
	    content = c.substring(0, width);
	} else {
	    content = c;
	}

	if (letters != null) {

	}

	int size = this.font.getSize();	
	//this.removeAll();
 
	//letters = new JLabel[c.length()];
	
	for (int i=0; i<content.length(); i++) {
	    letters[i].setText(content.substring(i,i+1));
	    //letters[i].setBorder(BorderFactory.createEtchedBorder());
	    //letters[i].setFont(font);
	    //letters[i].setPreferredSize(new Dimension(size*2/3,size*11/10));
	    //letters[i].setMaximumSize(new Dimension(size*2/3,size*11/10));
	    //this.add(letters[i]);
	    //System.out.println(letters[i].getPreferredSize());
	}
	for (int i=content.length(); i<this.width; i++) {
	    letters[i].setText("");
	}
	revalidate();

    }

    public void setForeground(Color c) {
	for (int i=0; i<this.width; i++) {
	    letters[i].setForeground(c);
	}
    }
    
    public void setFontSize(int size) {
	this.font = new Font("Monospaced", Font.PLAIN, size);
	for (int i=0; i<this.width; i++) {
	    letters[i].setFont(font);
	    letters[i].setPreferredSize(new Dimension(size*2/3,size*11/10));
	    letters[i].setMaximumSize(new Dimension(size*2/3,size*11/10));
	}
    }

    public void encrypt(Lettermap map) {
	StringBuffer neu = new StringBuffer(original);
	
	//System.out.println("original: "+original);
	for (int i=0; i<original.length(); i++) {
	    char c = original.charAt(i);
	    int p = Lettermap.charToInt(c);
	    if (p == -1) {
		p = 26;	    // unbekanntes Zeichen -> Leerzeichen
	    }
	    neu.replace(i, i+1, map.getString(p));
	}

	this.setText(neu.toString());
    }

    public void encrypt(HashMap map) {
	this.setText(Decaesar.apply_map_to_text(map, original));
    }

    public void setEnabled(boolean en) {
	for (int i=0; i<letters.length; i++) {
	    letters[i].setEnabled(en);
	}
    }
    
    public String toString() {
       return this.content;
    }
}


class Workbench extends JPanel {
    private Letterline oLine[];	// original
    public Letterline eLine[];	// encrypted
    private Letterline wLine[]; // work
    private Lettermap enMap = null;
    private Lettermap deMap = null;
    private HashMap hdeMap = null;

    public Workbench() {
	super();
    }

    public Workbench(Letterline[] lines, LettermapPanel lm) {
	this.oLine = lines;
	this.eLine = new Letterline[lines.length];
	this.wLine = new Letterline[oLine.length];

	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	this.setBorder(BorderFactory.createRaisedBevelBorder());

	for (int i=0; i<oLine.length; i++) {
	    eLine[i] = new Letterline(oLine[i].toString(), 32, 20);
	    eLine[i].setBackground(this.getBackground());
	    this.add(eLine[i]);
	    //lm.addListener(eLine[i]);

	    wLine[i] = new Letterline(eLine[i].toString(), 32, 20);
	    wLine[i].setForeground(Color.red);
	    wLine[i].setBackground(this.getBackground());
	    this.add(wLine[i]);
	}
	
	setEnMap(lm.getMap());

	//LettermapPanel m = new LettermapPanel();
	//deMap = m.getMap();
	deMap = new Lettermap();
    }

    public void setBackground(Color c) {
	super.setBackground(c);
	if (oLine != null) {
	    for (int i=0; i<oLine.length; i++) {
		eLine[i].setBackground(c);
		wLine[i].setBackground(c);
	    }
	}
    }
    
    public void setText(JTextArea ta) {	
	String t = "";
	for (int i=0; i<5; i++) {
	    //System.out.println(ta.getLineCount());
	    if (i < ta.getLineCount()) {
		try {
		    int a = ta.getLineStartOffset(i);
		    int b = ta.getLineEndOffset(i);
		    t = ta.getText(a, b-a).trim();
		    //System.out.println("a,b: "+a+","+b);
		} catch (javax.swing.text.BadLocationException e) {
		    System.err.println("Error in editCheckBox-ActionListener!"+e.getMessage());
		}
		oLine[i].setText(t);
		//System.out.println("t: "+t+"$");
	    } else {
	    //deText[i].setText("");
		//oLine[i].setText("                                ");
		oLine[i].setText("");
	    }
	    //System.out.println("olts: "+oLine[i].toString());
	    eLine[i].setOriginalText(oLine[i].toString());
	    eLine[i].encrypt(enMap);
	}
    }
			
    public String getEnText(int line) {
	return eLine[line].toString();
    }
    
    public String getEnText() {
	StringBuffer ret = new StringBuffer();

	for (int i=0; i<eLine.length-1; i++) {
	    if (eLine[i].toString().length() > 0 &&
		    eLine[i].toString().charAt(0) != '\n') {
		ret.append(eLine[i]).append(enMap.intToChar(26));
	    }
	}
	if (eLine[eLine.length-1].toString().length() > 0 &&
		eLine[eLine.length-1].toString().charAt(0) != '\n') {
	    ret.append(eLine[eLine.length-1]);
	}
	
	if (ret.charAt(ret.length()-1) == enMap.intToChar(26)) {
	    ret = ret.deleteCharAt(ret.length()-1);
	}

	return ret.toString();
    }

    public void setEnabled(boolean en) {
	super.setEnabled(en);
	for (int i=0; i<oLine.length; i++) {
	    //eLine[i].setEnabled(en);
	    wLine[i].setEnabled(en);
	}
    }
    
    public boolean isEnabled() {
	return super.isEnabled();
    }
    
    public void setEnMap(Lettermap map) {
	this.enMap = map;
	for (int i=0; i<eLine.length; i++) {
	    //System.out.println("elts0: "+eLine[i].toString());
	    eLine[i].encrypt(map);
	    //System.out.println("elts: "+eLine[i].toString());
	    wLine[i].setOriginalText(eLine[i].toString());
	}
    }
    
    public void setDeMap(HashMap map) {
	this.hdeMap = map;
	for (int i=0; i<wLine.length; i++) {
	    wLine[i].encrypt(map);
	}
    }
    
    public void setDeMap(Lettermap map) {
	this.deMap = map;
	for (int i=0; i<wLine.length; i++) {
	    wLine[i].encrypt(map);
	}
    }
}


class UpcaseDocument extends PlainDocument {
    protected int maxLineLength = 32;
    protected int maxLineCount = 5;

    //TODO: auch remove() berschreiben!
    public void insertString(int offs, String str, AttributeSet a) throws BadLocationException {
	str = str.toUpperCase();
	str = str.replaceAll("", "AE").replaceAll("", "OE").replaceAll("", "UE");
	
	for (int i=0; i<str.length(); i++) {
	    if (!Character.isLetter(str.charAt(i)) && str.charAt(i)!=' ' && str.charAt(i)!='\n') {
		return;
	    }
	}
	
	super.insertString(offs, str, a);
	//System.out.println("valid: "+hasValidContent());	
	if (hasValidContent() == false) {
	    remove(offs, str.length());
	}
    }

    private boolean hasValidContent() throws BadLocationException {
	String t = getText(0, getLength());
	int lines = 1;
	int linelen = 0;
	
	for (int i=0; i<t.length(); i++) {
	    if (t.charAt(i) == '\n') {
		lines++;
		if (lines > maxLineCount) {
		    return false;
		}
		if (linelen > maxLineLength) {
		    return false;
		}
		linelen = 0;
	    } else {
		linelen++;
	    }
	}
	if (linelen > maxLineLength) {
	    return false;
	}

	return true;
    }
    
    private String getTextLine(int line) {
	return null;
    }

    private int getLineCount() throws BadLocationException {
	String t = getText(0, getLength());
	int lines = 1;
	
	for (int i=0; i<t.length(); i++) {
	    if (t.charAt(i) == '\n') {
		lines++;
	    }
	}

	return lines;
    }
}

